function SwolRTB_saveBricks(%filename)
{
    %bricks = getBrickCount(); 
    if(%bricks <= 0)
        return;
   
    $SwolRTB_saveBricks = 0;
    $SwolRTB_saveStart = $Sim::Time;
    $SwolRTB_saveFilename = %filename;
	$SwolRTB_saving = true;

    $SwolRTB_savePath = "config/server/" @ %filename;
      
    %file = $SwolRTB_saveFile = new FileObject();
    %file.openForWrite($SwolRTB_savePath);
    %file.writeLine("This is a Blockland save file. You probably shouldn't modify it cause you'll screw it up.");
    %file.writeLine("1");
    %file.writeLine("Save function by RTB - Taken at " @ getDateTime());
   
    for(%i=0;%i<64;%i++)
        %file.writeLine(getColorIDTable(%i));
   
    %file.writeLine("Linecount TBD");

    SwolRTB_brickGroupDig(0);
}

//- RTB_Hosting::_saveEnd (called when saving is complete)
function SwolRTB_saveEnd()
{
    $SwolRTB_saveFile.close();
	$SwolRTB_saveFile.delete();

    $SwolRTB_saving = false;
   
    %diff = mFloatLength($Sim::Time - $SwolRTB_saveStart,2);
    if(getSubStr(%diff,0,1) $= "-")
        %diff = "0.00";
}

//- RTB_Hosting::_writeBrick (writes data for a single brick to file)
function SwolRTB_writeBrick(%brick)
{
    RTB_Hosting.saveBricks++;
   
    %print = (%brick.getDataBlock().hasPrint) ? getPrintTexture(%brick.getPrintID()) : "";
   
    %file = $SwolRTB_saveFile;
    %file.writeLine(%brick.getDataBlock().uiName @ "\" " @ %brick.getPosition() SPC %brick.getAngleID() SPC %brick.isBasePlate() SPC %brick.getColorID() SPC %print SPC %brick.getColorFXID() SPC %brick.getShapeFXID() SPC %brick.isRayCasting() SPC %brick.isColliding() SPC %brick.isRendering());
   
    if(%brick.isBasePlate())
        %file.writeLine("+-OWNER " @ getBrickGroupFromObject(%brick).bl_id);
    if(%brick.getName() !$= "")
        %file.writeLine("+-NTOBJECTNAME " @ %brick.getName());
    if(isObject(%brick.emitter))
        %file.writeLine("+-EMITTER " @ %brick.emitter.emitter.uiName @ "\" " @ %brick.emitterDirection);
    if(%brick.getLightID() >= 0)
        %file.writeLine("+-LIGHT " @ %brick.getLightID().getDataBlock().uiName @ "\" ");
    if(isObject(%brick.item))
        %file.writeLine("+-ITEM " @ %brick.item.getDataBlock().uiName @ "\" " @ %brick.itemPosition SPC %brick.itemDirection SPC %brick.itemRespawnTime);
    if(isObject(%brick.audioEmitter))
        %file.writeLine("+-AUDIOEMITTER " @ %brick.audioEmitter.getProfileID().uiName @ "\" ");
    if(isObject(%brick.vehicleSpawnMarker))
        %file.writeLine("+-VEHICLE " @  %brick.vehicleSpawnMarker.uiName @ "\" " @ %brick.reColorVehicle);
      
    for(%i=0;%i<%brick.numEvents;%i++)
    {
        %targetClass = %brick.eventTargetIdx[%i] >= 0 ? getWord(getField($InputEvent_TargetListfxDTSBrick_[%brick.eventInputIdx[%i]], %brick.eventTargetIdx[%i]), 1) : "fxDtsBrick";
        %paramList = $OutputEvent_parameterList[%targetClass, %brick.eventOutputIdx[%i]];
        %params = "";
        for(%j=0;%j<getFieldCount(%paramList);%j++)
        {
            if(firstWord(getField(%paramList,%j)) $= "dataBlock" && %brick.eventOutputParameter[%i,%j+1] >= 0)
                %params = %params TAB %brick.eventOutputParameter[%i, %j+1].getName();
            else
                %params = %params TAB %brick.eventOutputParameter[%i, %j+1];
        }
        %file.writeLine("+-EVENT" TAB %i TAB %brick.eventEnabled[%i] TAB %brick.eventInput[%i] TAB %brick.eventDelay[%i] TAB %brick.eventTarget[%i] TAB %brick.eventNT[%i] TAB %brick.eventOutput[%i] @ %params);
    }
}

//- RTB_Hosting::_brickGroupDig (digs through brick groups)
function SwolRTB_brickGroupDig(%index)
{
    if(%index >= mainBrickGroup.getCount())
    {
        SwolRTB_saveEnd();
        return;
    }
    SwolRTB_brickDig(mainBrickGroup.getObject(%index),0,%index,%count);
}

//- RTB_Hosting::_brickDig (recurses through a brick group in a semi-non-blocking way)
function SwolRTB_brickDig(%group,%index,%childIndex,%count)
{
    if(%index >= %group.getCount())
    {
        SwolRTB_brickGroupDig(%childIndex++);
        return;
    }

    if(!isObject($SwolRTB_saveFile))
    {
        $SwolRTB_saveFile = new FileObject();
        $SwolRTB_saveFile.openForAppend($SwolRTB_savePath);
    }
    SwolRTB_writeBrick(%group.getObject(%index));
   
    if(%count >= 500)
    {
        $SwolRTB_saveFile.close();
        $SwolRTB_saveFile.delete();

        schedule(100,0,$SwolRTB_brickDig,%group,%index++,%childIndex,0);
    }
    else
       SwolRTB_brickDig(%group,%index++,%childIndex,%count++);
}